<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8" />
    <title>Chat using Deno</title>
</head>

<body>
    <input id="id" type="number"><input id="message"><button id="send">send</button>
    <div id="messages"></div>
    <script>
        const id = document.getElementById("id")
        const message = document.getElementById("message")
        const send = document.getElementById("send");
        const messages = document.getElementById("messages");
        const socket = new WebSocket(`ws://${window.location.host}/ws`);
        socket.onmessage = async (event) => {
            const ev = new Uint8Array(await event.data.arrayBuffer());
            const id = new Uint8Array(ev, 0, 1)[0];
            const slice = Uint8Array.BYTES_PER_ELEMENT * 1
            const noHeader = ev.buffer.slice(slice);
            const text = await new Blob([noHeader]).text();
            console.log(`[${id}] ${text}`);
            messages.innerHTML = `[${id}] ${text}` + "<br />" + messages.innerHTML;
        }
        send.onclick = async () => {
            let rawHeader = [id.value];
            let header = new Uint8Array(rawHeader);
            let output = new Blob([header, message.value]);
            const returning = await output.arrayBuffer();
            socket.send(returning);
        }
    </script>
</body>

</html>